#include <mega8.h>
#include <delay.h>
#include <stdio.h> 

#asm
   .equ __lcd_port=0x18 ;PORTB
#endasm
#include <lcd.h>

#define button_ddr  DDRD
#define button_port PORTD
#define button_pin  PIND
//
#define but_start   2  
#define but_stop    3
#define odin_raz    4
#define ch_plus     5
#define ch_minus    6

#define ADC_VREF_TYPE 0x00;

char lcd_buffer[31]; 
unsigned int result;
unsigned char num_ch=1;
unsigned char buf;
unsigned char vikl=1; 

interrupt [ADC_INT] void adc_isr(void){
 
 result=ADCW*5-ADCW/10; //       
 printf("result=%dmv ",result); //       
 printf("number of channel=%d",num_ch);   //  
 putchar(0x0D);              //     
  sprintf(lcd_buffer,"ADC=%4umV      num_ch=%1u",result,num_ch);//        2 
  lcd_clear();                 //      
  lcd_puts(lcd_buffer);         //      
 delay_ms(1);
 if (vikl==0) ADCSRA=0b11011111;
 
 }

interrupt [EXT_INT0] void ext_int0_isr(void)
{
 // 
 vikl=0;      
 ADCSRA=0b11011111; 
}

// External Interrupt 1 service routine
interrupt [EXT_INT1] void ext_int1_isr(void)
{
// 
  ADCSRA=0;
  vikl=1;
}  
             
void init(void){

  ADCSRA=0b10011111;
  ADMUX=0;
 button_ddr=0x00;
 button_port=0xFC; 
 PORTB=0x00;
  MCUCR = 0x0A;
  GICR  = 0xC0;
 UCSRA=0x00;
 UCSRB=0x18;
 UCSRC=0x86;
 UBRRH=0x00;
 UBRRL=0x0C;

 #asm ("sei");
 lcd_init(16);                    //  
 }

void main(void)
{
  init();                          //    

  lcd_gotoxy(0,0);                 //     
  lcd_putsf("-=ADC&UART&LCD=-");  //  
  lcd_gotoxy(3,1);                //    
  lcd_putsf("-=Aliens=-");       //  
  
  printf("Nagmi 0 dlya spravki"); //
  putchar(0x0D);

 while(1){
    
    if (!(button_pin.odin_raz)){
     ADCSRA=0b11011111;
     //button_port=0xFC; 
     }
    if (button_pin.ch_plus) num_ch++;
    
    if (button_pin.ch_minus) num_ch--;
         
    buf=getchar();
    
    if (buf==0x39){
     ADCSRA=0;
     vikl=1;
      }
    if (buf==0x38)
     ADCSRA=0b11011111;
    if (buf==0x37){
     vikl=0;      
     ADCSRA=0b11011111;
     }
     
    if (buf==0x30){
     printf("Opisanie klavish:");
     putchar(0x0D);
     printf("1-6 - vibor kanala");
     putchar(0x0D);
     printf("9 - vikluchit");
     putchar(0x0D);
     printf("8 - odno preobrazovanie"); 
     putchar(0x0D);
     }
    
    if (buf==0x31){
     ADMUX=0;
     num_ch=1;
      }
    if (buf==0x32){
     ADMUX=1;
     num_ch=2;
      }
    if (buf==0x33){
     ADMUX=2;
     num_ch=3;
      }
    if (buf==0x34){
     ADMUX=3;
     num_ch=4;
      }
    if (buf==0x35){
     ADMUX=4;
     num_ch=5;
      }
    if (buf==0x36){
     ADMUX=5;
     num_ch=6;
      }
    
    }
 }
